/* Problem URL: https://codeforces.com/problemset/problem/2042/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;
    V<tuple<ll, ll, int>> fds(n);
    rep(i, n) {
        auto &[l, r, j] = fds[i];
        cin >> l >> r;
        j = i;
    }

    sort(all(fds), [&](tuple<ll, ll, int> &a, tuple<ll, ll, int> &b){
         auto [la, ra, ia] = a;
         auto [lb, rb, ib] = b;

         if (la == lb) {
         return ra > rb;
         }
         return la < lb;
         });

    set<ll> lesser;
    lesser.insert(get<1>(fds[0]));

    vl ans(n);


    nrep(i, 1, n) {
        auto [l, r, j] = fds[i];

        if (i < n - 1 && get<0>(fds[i + 1]) == l && get<1>(fds[i + 1]) == r) {
            lesser.insert(r);
            continue;
        }

        auto itr = lesser.lower_bound(r);
        lesser.insert(r);
        if (itr == lesser.end()) {
            continue;
        }

        ans[j] = *itr - r;
    }

    sort(all(fds), [&](tuple<ll, ll, int> &a, tuple<ll, ll, int> &b){
         auto [la, ra, ia] = a;
         auto [lb, rb, ib] = b;

         if (ra == rb) {
         return la < lb;
         }
         return ra > rb;
         });

    set<ll, greater<>> greater;
    greater.insert(get<0>(fds[0]));

    nrep(i, 1, n) {
        auto [l, r, j] = fds[i];

        if (i < n - 1 && get<0>(fds[i + 1]) == l && get<1>(fds[i + 1]) == r) {
            greater.insert(l);
            continue;
        }

        auto itr = greater.lower_bound(l);
        greater.insert(l);
        if (itr == greater.end()) {
            continue;
        }

        ans[j] += l - *itr;
    }

    rep(i, n) {
        cout << ans[i] << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
